Subject: Re: [rtcweb] JSEP: Usage of a=rtcp attribute

From: Justin Uberti <[email-masked]>
Date: Fri, 8 Jan 2016 17:41:27 -0800

Unfortunately, that would contradict 5245. See
https://tools.ietf.org/html/rfc5245#section-4.3, 6th para.

Perhaps we could say that trickle with non-mux-exclusive should use
a=rtcp:10 or some such...

On Sun, Dec 13, 2015 at 7:02 AM, Christer Holmberg <
[email-masked]> wrote:

> Hi,
>
>
>
> Section 5.2.1 of draft-jsep contains the following statement:
>
>
>
>    “o  An "a=rtcp" line, as specified in [RFC3605], Section 2.1,
>
>       containing the dummy value "9 IN IP4 0.0.0.0", because no
>
>       candidates have yet been gathered.”
>
>
>
> …i.e. the same port:address as in the associated c/m-line.
>
>
>
> The problem is that the currently suggested mechanism to indicate
> exclusive support of RTP/RTCP-mux also says that the a=rtcp line shall be
> identical to the c/m-line.
>
>
>
> My question is: is there really a need to always include the rtcp
> attribute in trickle offers? Isn’t it enough to indicate port 9 in the m-
> line, and address 0.0.0.0 in the c-line? In my opinion that would also
> apply to RTCP.
>
>
>
> Example:
>
>
>
> JSEP trickle offer **without** mux-exclusive indication:
>
>
>
> c=IN IP4 0.0.0.0
>
> m=audio 9…
>
> a=rtcp-mux
>
>
>
> JSEP trickle offer **with** mux-exclusive indication:
>
>
>
> c=IN IP4 0.0.0.0
>
> m=audio 9…
>
>               *a=rtcp: 9 IN IP4 0.0.0.0*
>
>               a=rtcp-mux
>
>
>
> Regards,
>
>
>
> Christer
>
> _______________________________________________
> rtcweb mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtcweb
>
>

---

From: Christer Holmberg <[email-masked]>
Date: Sat, 9 Jan 2016 05:32:23 +0000

Hi,

Eventhough the text in 5245 is a little unclear (should probably be fixed in 5245bis) I don't think it says that you must include the rtcp attribute - it describes how to encode the rtcp candidate.

Regards,

Christer

Sent from my Windows Phone
________________________________
From: Justin Uberti<mailto:[email-masked]>
Sent: ‎09/‎01/‎2016 03:41
To: Christer Holmberg<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [rtcweb] JSEP: Usage of a=rtcp attribute

Unfortunately, that would contradict 5245. See https://tools.ietf.org/html/rfc5245#section-4.3, 6th para.

Perhaps we could say that trickle with non-mux-exclusive should use a=rtcp:10 or some such...

On Sun, Dec 13, 2015 at 7:02 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

The problem is that the currently suggested mechanism to indicate exclusive support of RTP/RTCP-mux also says that the a=rtcp line shall be identical to the c/m-line.

My question is: is there really a need to always include the rtcp attribute in trickle offers? Isn’t it enough to indicate port 9 in the m- line, and address 0.0.0.0 in the c-line? In my opinion that would also apply to RTCP.

Example:

JSEP trickle offer *without* mux-exclusive indication:

c=IN IP4 0.0.0.0
m=audio 9…
a=rtcp-mux

JSEP trickle offer *with* mux-exclusive indication:

c=IN IP4 0.0.0.0
m=audio 9…
              a=rtcp: 9 IN IP4 0.0.0.0
              a=rtcp-mux

Regards,

Christer

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

---

From: Roman Shpount <[email-masked]>
Date: Sat, 9 Jan 2016 23:31:57 -0500

Hi,

To add to above, if default RTCP candidate is on the same address as RTP
and is using RTP port+1, why is SDP rtcp attribute is still required? It is
totally redundant. Does anybody know the reason why rtcp SDP attribute was
made a requirement in RFC 5245?

Regards,

_____________
Roman Shpount

On Sat, Jan 9, 2016 at 12:32 AM, Christer Holmberg <
[email-masked]> wrote:

> Hi,
>
> Eventhough the text in 5245 is a little unclear (should probably be fixed
> in 5245bis) I don't think it says that you must include the rtcp attribute
> - it describes how to encode the rtcp candidate.
>
> Regards,
>
> Christer
>
>
> ------------------------------
> From: Justin Uberti <[email-masked]>
> To: Christer Holmberg <[email-masked]>
> Cc: [email-masked]

---

From: Justin Uberti <[email-masked]>
Date: Sun, 10 Jan 2016 14:24:37 -0800

I think the text is pretty clear that you need to add an a=rtcp attribute:

   The default candidates are added to the SDP as the default
   destination for media.  For streams based on RTP, this is done by
   placing the IP address and port of the RTP candidate into the c and m
   lines, respectively.  *If the agent is utilizing RTCP, it MUST encode
   the RTCP candidate using the a=rtcp attribute as defined in RFC
3605 <https://tools.ietf.org/html/rfc3605>
   [RFC3605 <https://tools.ietf.org/html/rfc3605>].*  If RTCP is not
in use, the agent MUST signal that using
   b=RS:0 and b=RR:0 as defined in RFC 3556
<https://tools.ietf.org/html/rfc3556> [RFC3556
<https://tools.ietf.org/html/rfc3556>].

---

From: Christer Holmberg <[email-masked]>
Date: Mon, 11 Jan 2016 12:35:04 +0000

Hi,

I think we could clarify that the attribute is used only if there is a real port, and if something is to be sent.

Regards,

Christer

From: Justin Uberti [mailto:[email-masked]]
Sent: 11. tammikuuta 2016 0:25
To: Christer Holmberg
Cc: [email-masked]
Subject: Re: [rtcweb] JSEP: Usage of a=rtcp attribute

   lines, respectively.  If the agent is utilizing RTCP, it MUST encode

   the RTCP candidate using the a=rtcp attribute as defined in RFC 3605<https://tools.ietf.org/html/rfc3605>

   [RFC3605<https://tools.ietf.org/html/rfc3605>].  If RTCP is not in use, the agent MUST signal that using

   b=RS:0 and b=RR:0 as defined in RFC 3556<https://tools.ietf.org/html/rfc3556> [RFC3556<https://tools.ietf.org/html/rfc3556>].

On Fri, Jan 8, 2016 at 9:32 PM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

Regards,

Christer

Example:

c=IN IP4 0.0.0.0
m=audio 9…
a=rtcp-mux

c=IN IP4 0.0.0.0
m=audio 9…
              a=rtcp: 9 IN IP4 0.0.0.0
              a=rtcp-mux

Regards,

Christer

---

From: Roman Shpount <[email-masked]>
Date: Mon, 11 Jan 2016 10:42:43 -0500

On Mon, Jan 11, 2016 at 7:35 AM, Christer Holmberg <
[email-masked]> wrote:

> I think we could clarify that the attribute is used only if there is a
> real port, and if something is to be sent.
>
>
>
This most likely be a change to RFC 5245 not a clarification. It can
definitely be proposed for RFC 5245 bis to ice working group.
_____________
Roman Shpount

---

From: Christer Holmberg <[email-masked]>
Date: Mon, 11 Jan 2016 16:12:14 +0000

Hi,

If we put it in 5245bis I assume JSEP (and trickle ICE) would have to reference 5245bis. Currently I think both of those specs reference 5245, but I may be wrong.

It can be discussed whether it's a change or clarification. 5245 says that the RTCP candidate shall be encoded using the rtcp attribute - but if you are doing trickle there is no candidate to encode.

Regards,

Christer

Sent from my Windows Phone
________________________________
From: Roman Shpount<mailto:[email-masked]>
Sent: ‎11/‎01/‎2016 17:42
To: Christer Holmberg<mailto:[email-masked]>
Cc: Justin Uberti<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [rtcweb] JSEP: Usage of a=rtcp attribute

On Mon, Jan 11, 2016 at 7:35 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:
I think we could clarify that the attribute is used only if there is a real port, and if something is to be sent.

This most likely be a change to RFC 5245 not a clarification. It can definitely be proposed for RFC 5245 bis to ice working group.
_____________
Roman Shpount

---

From: Cullen Jennings <[email-masked]>
Date: Tue, 12 Jan 2016 12:34:12 -0700

Having the attribute indicates that the device is capable of rtcp on a port other than the rtp+1 port 

> On Jan 11, 2016, at 9:12 AM, Christer Holmberg <[email-masked]> wrote:
> 
> Hi,
> 
> From: Roman Shpount
> Cc: Justin Uberti; [email-masked]
> On Mon, Jan 11, 2016 at 7:35 AM, Christer Holmberg <[email-masked]> wrote:

---

From: Roman Shpount <[email-masked]>
Date: Tue, 12 Jan 2016 15:25:05 -0500

> port other than the rtp+1 port

First of all, according to  RFC 5245 rtcp SDP attribute must be present
even if RTCP is being received on  rtp+1 port. Furthermore, RFC 5245
also specifies that if RTCP is not being used, b=RS:0 and b=RR:0 must be
present. If most of the cases (especially if TURN candidates are default,
which is the recommended behavior), default ICE candidate for RTCP is rtp+1
port, which makes it SDP rtcp attribute totally redundant.

More importantly, as far as initial offer for trickle ICE is concerned, I
do no think there are any use cases which would be negatively affected by
SDP rtcp attribute not being present in the initial offer with no
candidates. We can argue regarding RFC 5245 usage of rtcp attribute, or we
can get trickle ICE to update RFC 5245 (which it does anyway) and specify
that initial offer with no candidates MUST NOT include SDP rtcp attribute
unless rtcp-mux is required.
_____________
Roman Shpount

---

From: Christer Holmberg <[email-masked]>
Date: Tue, 12 Jan 2016 20:40:31 +0000

Hi,

>Having the attribute indicates that the device is capable of rtcp on a port other than the rtp+1 port 

Any why is that useful information? It doesn't say anything about WHICH other port(s).

And, once the device starts providing the candidates, the remote endpoint will figure out (from the host candidate) on which local ports the device can receive RTCP.

Regards,

Christer